library colorfilter_generator;

import 'package:matrix2d/matrix2d.dart';

///The [ColorFilterGenerator] class to define a Filter which will applied to each color, consists of multiple [SubFilter]s
class ColorFilterGenerator {
  String name;
  List<List<double>> filters;
  ColorFilterGenerator({
    required this.name,
    required this.filters,
  });

  List<double> get matrix {
    Matrix2d m2d = const Matrix2d();

    List result = m2d.reshape(filters[0], 4, 5);

    for (int i = 1; i < filters.length; i++) {
      result = m2d.dot(
        result,
        m2d.reshape(
          filters[i] is ColorFilterGenerator
              ? (filters[i] as ColorFilterGenerator).matrix
              : filters[i],
          4,
          5,
        ),
      );
    }

    return result.flatten as List<double>;
  }

  ColorFilterGenerator opacity(double value) {
    filters.add([
      value,
      0,
      0,
      0,
      0,
      0,
      value,
      0,
      0,
      0,
      0,
      0,
      value,
      0,
      0,
      0,
      0,
      0,
      1,
      0,
    ]);

    return this;
  }
}
